
package java_cup.interpreter;

/** class describing the form of a method.
 * @author Andi Bejleri
 * @version 0.1
 */
public class Method implements Cloneable{
    
    /** the outmost argument of the method */
    String arg;
    /** the type of @see arg  */
    String type;
    /** the method body  */
    Value code;
    /** tag to distinguish between linear or nonlinear methods */
    char linearity;

    Method(String var, String type_var, Value code, char linearity){
	
	this.arg = var;
	this.type = type_var;
	this.code = code;
	this.linearity = linearity;
    }

    /** clone a @see Method object.
       @return a new @see Method object with the same content of the receiver.
    */
    public Object clone(){

	return new Method(new String(arg), new String(type), (Value) code.clone(), linearity);
    } 
   
    /** the overriding toString() of java.lang.Object.
     *@see <a href = "java.lang.Object">
     *@return a string of presenting the content of the receiver. 
    */
    public String toString(){

	if(this.linearity == 'n')
	    return "fn ".concat(arg).concat(":|").concat(type).concat("|.").concat(code.toString());
	else
	    return "bang_fn ".concat(arg).concat(":|").concat(type).concat("|.").concat(code.toString());
    }
}
