
package java_cup.interpreter;

/** a not evaluated expression is a container for a method body when a new method is added to a location and evaluated when an apply operation is called 
 *@author Andi Bejleri
 *@version 0.1
*/
class NotEvaluatedExpr{
    
    /** variable containg an operation: clone, addMethod, delegate, apply, invoke, change_linearity */
    String operation; 
    /** a not evaluated expression  */
    Value expr;
    /** an optional parameter used for addMethod, delegate, apply, inoke  */
    Object op_par;

    NotEvaluatedExpr( String operation, Value expr, Object op_par ){
	
	this.operation = operation;
	this.expr = expr;
	this.op_par = op_par;
    }

    NotEvaluatedExpr( String operation, Value expr){
	
	this.operation = operation;
	this.expr = expr;
	this.op_par = null;
    }
    
    public Object clone(){
	
	if( op_par == null)
	    return new NotEvaluatedExpr( new String( operation ), (Value)expr.clone());
	else
	    if( op_par instanceof Method_descriptor)
		return new NotEvaluatedExpr( new String( operation ), (Value)expr.clone(), ((Method_descriptor)op_par).clone() );
	    else if( op_par instanceof Value )
		return new NotEvaluatedExpr( new String( operation ), (Value)expr.clone(), ((Value)op_par).clone());
	    else 
		return new NotEvaluatedExpr( new String( operation ), (Value)expr.clone(), new String((String)op_par));
    }
    
   public String toString(){
       
	if( operation.compareTo("clone") == 0 )
	    /* clone */
	    return "clone(" + expr.toString() + ")";
	else if( operation.compareTo("delegate") == 0 )
		/* delegate */
	    return expr.toString()+".delegate(" + ((Value)op_par).toString() + ")";
	else if( operation.compareTo("addMethod") == 0 )
	    /* addMethod */
	    return expr.toString()+".addMethod(" +((Method_descriptor)op_par).toString()  + ")";
	else if( operation.compareTo("apply") == 0 )
	    /* apply */
	    return "apply("+expr.toString()+", "+op_par.toString()+")";
	else if( operation.compareTo("invk") == 0 )
	    /* invoke */
	    return expr.toString()+"."+(String)op_par;
	else if( operation.compareTo("change") == 0 )
	    /* change_linearity */
	    return "change_linearity("+expr.toString()+")";
	else
	    /* var */
	    return operation;
    }
}
