
package java_cup.interpreter;

import java.util.LinkedList;
import java.util.ListIterator;
/** class containing the implementation of an object descriptor in the store 
 *@author Andi bejleri
 *@version 0.1
*/
class Object_descriptor implements Cloneable{

    /** the super object. */
    Value deleg;
    /** list of methods owned by the location */
    LinkedList methods;
    
    Object_descriptor(Value deleg, LinkedList methods){

	this.deleg = deleg;
	this.methods = methods;
    }

    public Object clone(){
	
	return new Object_descriptor( (Value) deleg.clone(), (LinkedList) copy_methods() );
    }

    LinkedList copy_methods(){

	if(!methods.isEmpty()){
	    
	    LinkedList copy = new LinkedList();
	    ListIterator iterator = methods.listIterator(0);
	    Method_descriptor method = null;
	    do{
		method = (Method_descriptor)iterator.next();
		copy.add(method.clone());		
	    }while(iterator.hasNext());
	    
	    return copy;
	}
	else 
	    return new LinkedList();
    }
    public String toString(){
	
	String list = "< super -> ";
	if( deleg != null )
	    list = list + deleg.toString()+", ";
	else
	    list = list + ",";
	if(!methods.isEmpty()){
	    ListIterator iterator = methods.listIterator(0);
	    Method_descriptor method = null;
	    do{
		method = (Method_descriptor)iterator.next();
		list = list + method.toString();		
	    }while(iterator.hasNext());
	    
	    return list+">";
	}
	else
	    return list + " >";
    }
}
