
package java_cup.interpreter;

/** A value is an object descriptor, a method, an unevaluated expression or a string Object
 *@author Andi Bejleri
 *@version 0.1
*/
class Value implements Cloneable{
    
    Object_descriptor object_descriptor;
    Method method;
    NotEvaluatedExpr expr;
    String object;
    
    /**A constructor for just locations.       
    */
    Value(Object_descriptor object_descriptor){

	this.object_descriptor = object_descriptor;
	this.method = null;
	this.expr = null;
	this.object = null;
    }
    /**
       Constructor for just methods.
     */
    Value(Method meth){
	
	this.object_descriptor = null;
	this.method = meth;
	this.expr = null;
	this.object = null;
    }
    /**
       Constructor for just un evaluated expressions.
    */
    Value(NotEvaluatedExpr expr){
	
	this.object_descriptor = null;
	this.method = null;
	this.expr = expr;
	this.object = null;
    }
    /**
       Constructor for variables in method bodies and also used for the defined location Object.
     */
    Value(String object){
	
	this.object_descriptor = null;
	this.method = null;
	this.expr = null;
	this.object = object;
    }

    public Object clone(){
	
	if( object != null)
	    return new Value(object);
	else if( expr != null )
	    return new Value((NotEvaluatedExpr)expr.clone());
	else if ( object_descriptor != null )
	    return new Value((Object_descriptor) object_descriptor.clone() );
	else
	    return new Value( (Method) method.clone() );
    }
    
    public String toString(){
	
	if( object_descriptor != null )
	    /* The value is a location */
	    return object_descriptor.toString();
	else if( method != null )
	    return method.toString();
	else if( object != null )
	    return object;
	else 
	    return expr.toString();
    }
}
